from flask import Flask, render_template, request, redirect, url_for, flash
from flask_mysqldb import MySQL

app = Flask(__name__)

#Conexion base de datos
app.config['MYSQL_HOST'] = '127.0.0.1'
app.config['MYSQL_USER'] = 'root'
app.config['MYSQL_PASSWORD'] = ''
app.config['MYSQL_DB'] = 'servicioautomotriz'
mysql = MySQL(app)

# Sesion
app.secret_key = 'clavesecreta'

@app.route('/')
def index():
    return render_template('index.html')

#Agregar automovil
@app.route('/agregarautomovil', methods = ['POST'])
def agregarautomovil():
    if request.method == 'POST':
        #guardo en variables los valores
        placa1 = request.form['placa']
        placa = placa1.strip()
        print('/'+placa1+'/'+'limpia:/'+placa+'/')
        modelo = request.form['modelo']
        marca = request.form['marca']
        dueno = request.form['dueno']
        color = request.form['color']
        contacto = request.form['contactotel']
        descripcion = request.form['descripcion']

        if placa == '' or modelo == '' or marca == '' or dueno == '' or color == '' or contacto == '' or descripcion == '':
            flash('Todos los campos deben estar completos')
        else:
            cur = mysql.connection.cursor()
            cur.execute('SELECT `placa` FROM `automoviles` WHERE `placa` = "'+placa+'"')
            cur.fetchall
            if  cur.rowcount == 0:
            #Insertar a mysql
                cur = mysql.connection.cursor()
                #Insertar consulta
                cur.execute('INSERT INTO automoviles (placa, modelo, marca, dueno, color, contacto, descripcion) VALUES (%s, %s, %s, %s, %s, %s, %s)',
                (placa, modelo, marca, dueno, color, contacto, descripcion))
                #Ejecucion de consulta
                mysql.connection.commit()
                #Mensaje
                flash('Automovil agregado correctamente')
            else:
                flash('Placa existente en los registros')
        #Redireccionar a una url
        return redirect(url_for('paneladministrador'))

@app.route('/editarautomovil/<placa>')
def editarautomovil(placa):
    cur = mysql.connection.cursor()
    cur.execute('SELECT * FROM automoviles WHERE placa = %s', [placa])
    automovil = cur.fetchall()
    return render_template('editarAutomovil.html', automovil = automovil[0])

@app.route('/actualizarautomovil/<placa>', methods = ['POST'])
def actualizarautomovil(placa):
    if request.method == 'POST':
        #guardado en variables
        placaantigua = placa
        placa = request.form['placa']
        modelo = request.form['modelo']
        marca = request.form['marca']
        dueno = request.form['dueno']
        color = request.form['color']
        
        cur = mysql.connection.cursor()
        cur.execute(""" 
            UPDATE automoviles
            SET placa = %s,
                modelo = %s,
                marca = %s,
                dueno = %s,
                color = %s
            WHERE placa = %s
        """, (placa, modelo, marca, dueno, color, placaantigua))
        mysql.connection.commit()
        flash('Automovil actualizado correctamente')
        return redirect(url_for('paneladministrador'))

@app.route('/eliminarautomovil/<placa>')
def eliminarautomovil(placa):
    cur = mysql.connection.cursor()
    cur.execute('DELETE FROM automoviles WHERE placa = %s', [placa])
    mysql.connection.commit()
    flash('Automovil eliminado correctamente')
    return redirect(url_for('paneladministrador'))

@app.route('/paneladministrador')
def paneladministrador():
    cur = mysql.connection.cursor()
    cur.execute('SELECT * FROM automoviles')
    automoviles = cur.fetchall()
    return render_template('paneladministrador.html', automoviles = automoviles)

@app.route('/iniciarsesion', methods = ['POST'])
def login():
    if request.method == 'POST':
        #guardo en variables los valores
        usuario = request.form['user']
        password = request.form['pass']

    cur = mysql.connection.cursor()
    cur.execute('SELECT usuario FROM usuarios WHERE usuario = "'+ usuario + '" and pass = "'+ password +'";')
    cur.fetchall()

    if cur.rowcount == 0: 
        flash('Usuario/contraseña incorrectos')
        return redirect(url_for('iniciarsesion'))
    elif cur.rowcount == 1: 
        return redirect(url_for('paneladministrador'))
    
@app.route('/iniciarsesion')
def iniciarsesion():
   
    return render_template('login.html')

@app.route('/registro')
def registro():
    return render_template('register.html')

@app.route('/registro', methods = ['POST'])
def register():
    if request.method == 'POST':
        #guardo en variables los valores
        usuario = request.form['user']
        password = request.form['pass']
        password2 = request.form['pass2']

        if len(usuario) != 0 and len(password) >= 8 and len(password2) >= 8:
            if password == password2:
                cur = mysql.connection.cursor()
                cur.execute('SELECT usuario FROM usuarios WHERE usuario = "'+ usuario + '"')
                cur.fetchall()
                cur.rowcount
                if cur.rowcount == 0:
                    cur = mysql.connection.cursor()
                    #Insertar consulta
                    cur.execute('INSERT INTO `usuarios`(`usuario`, `pass`) VALUES ("'+usuario+'", '+'"'+password+'")')
                    #Ejecucion de consulta
                    mysql.connection.commit()
                    #Mensaje
                    flash('Registro correcto, ahora inicie sesion')
                    return redirect(url_for('iniciarsesion'))
                else:
                    flash('Usuario existente')
                    return redirect(url_for('registro'))
            else:
                flash('Las contraseñas son distitintas')
                return redirect(url_for('registro'))
        else:
            if password == password2 and len(password) <8:
                flash('La contraseña no puede ser menor a 8 dígitos')
            else:
                flash('Campos incompletos, vuelva a intentar')
            return redirect(url_for('registro'))

app.run(host='0.0.0.0', debug=True)
